VERSION 5.00
Begin VB.Form BCExpander 
   Caption         =   "BC Expander"
   ClientHeight    =   1725
   ClientLeft      =   60
   ClientTop       =   585
   ClientWidth     =   2655
   Icon            =   "BCExpander.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1725
   ScaleWidth      =   2655
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Copy 
      Caption         =   "&Copy"
      Height          =   495
      Left            =   960
      TabIndex        =   2
      Top             =   960
      Width           =   735
   End
   Begin VB.OptionButton typePatron 
      Caption         =   "&Patron"
      Height          =   255
      Left            =   1320
      TabIndex        =   5
      Top             =   120
      Width           =   855
   End
   Begin VB.OptionButton typeItem 
      Caption         =   "&Item"
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   120
      Value           =   -1  'True
      Width           =   615
   End
   Begin VB.CommandButton Exit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   1800
      TabIndex        =   3
      Top             =   960
      Width           =   735
   End
   Begin VB.CommandButton Expand 
      Caption         =   "&Expand"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   735
   End
   Begin VB.TextBox Barcode 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   2055
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   2760
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu menuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuExpand 
         Caption         =   "&Expand"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuClear 
         Caption         =   "Clea&r"
      End
      Begin VB.Menu mnuDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuChangeDigits 
         Caption         =   "C&hange Library Digits"
      End
      Begin VB.Menu mnuCalcCheckDigit 
         Caption         =   "Calculate Check &Digit"
      End
      Begin VB.Menu mnuVerifyCheckDigit 
         Caption         =   "&Verify Check Digit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpHelp 
         Caption         =   "&Help"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "BCExpander"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Library$
Public BarcodeType$
Public PatronCode$
Public ItemCode$

Private Sub Copy_Click()
  If Len(Barcode.Text) <> 14 Then
    MsgBox "Invalid barcode: Not expanded"
    Barcode.SetFocus
    Barcode.SelStart = Len(Barcode.Text)
  End If
  Clipboard.SetText Barcode.Text
  Barcode.Text = ""
  Barcode.SetFocus
  'Barcode.SelStart = Len(Barcode.Text)
End Sub

Private Sub Expand_Click()
  Header$ = Library$
  If typeItem = True Then
    Header = ItemCode$ + Header$
  Else
    Header = PatronCode$ + Header$
  End If
  Barcode.Text = Trim(Barcode.Text)
  If (Len(Barcode.Text) > 9 And Len(Barcode.Text) < 14) Then
    MsgBox "Unable to expand: Too many digits"
    GoTo ExitSub
  ElseIf Len(Barcode.Text) > 14 Then
    MsgBox "Invalid barcode: Too many digits"
    GoTo ExitSub
  ElseIf Len(Barcode.Text) = 14 Then
    If IsNumeric(Barcode.Text) = False Then
      MsgBox "Invalid barcode: Not numeric"
      GoTo ExitSub
    End If
    valid = mBCE.CodabarCheckDigit(Left(Barcode.Text, 13))
    If valid = Right(Barcode.Text, 1) Then
      MsgBox "Barcode is expanded and valid."
    Else
      MsgBox "Invalid barcode: Invalid check digit"
    End If
    GoTo ExitSub
  ElseIf Trim(Barcode.Text) = "" Then
    MsgBox "No barcode entered"
    GoTo ExitSub
  End If
  If IsNumeric(Barcode.Text) = False Then
    MsgBox "Invalid barcode: Not numeric"
    GoTo ExitSub
  End If
  BCode$ = Header + Right("000000000" + Barcode.Text, 9)
  valid = mBCE.CodabarCheckDigit(Left(BCode$, 13))
  If valid = Right(Barcode.Text, 1) Then
    Barcode.Text = BCode$
  Else
    MsgBox "Invalid barcode: Invalid check digit"
  End If

ExitSub:
  Barcode.SetFocus
  Barcode.SelStart = Len(Barcode.Text)
End Sub

Private Sub Exit_Click()
  Call mBCE.WriteIni(BarcodeType$, Library$, PatronCode$, ItemCode$)
  End
End Sub

Private Sub Form_Load()
  bcpath = App.Path
  BarcodeType$ = "0"
  Library$ = "0000"
  PatronCode$ = "2"
  ItemCode$ = "3"
  
  retval = Dir(bcpath + "\bcexpndr.ini")
  If retval = "" Then
    Call mBCE.WriteIni(BarcodeType$, Library$, PatronCode$, ItemCode$)
  Else
    Call mBCE.GetIni(BarcodeType$, Library$, PatronCode$, ItemCode$)
  End If
  
  About.Hide
  Help.Hide
    
  If BarcodeType$ = "0" Then
    BCExpander.typeItem.Value = True
    BCExpander.typePatron.Value = False
  Else
    BCExpander.typeItem.Value = False
    BCExpander.typePatron.Value = True
  End If
  
  If PatronCode$ = "0" Then PatronCode$ = "2"
  If ItemCode$ = "0" Then ItemCode$ = "3"
  
  If Library$ = "0000" Then
    ChangeLib.Show 1
    Call mBCE.WriteIni(BarcodeType$, Library$, PatronCode$, ItemCode$)
  End If
End Sub

Private Sub mnuAbout_Click()
  About.Show 1
End Sub

Private Sub mnuCalcCheckDigit_Click()
  If typeItem = True Then
    Header$ = ItemCode$ + Library$
  Else
    Header$ = PatronCode$ + Library$
  End If
  Barcode.Text = Trim(Barcode.Text)
  If (Len(Barcode.Text) >= 9 And Len(Barcode.Text) < 13) Or Len(Barcode.Text) > 13 Then
    MsgBox "Invalid barcode: Too many digits"
    GoTo ExitSub
  ElseIf Len(Barcode.Text) = 13 Then
    If IsNumeric(Barcode.Text) = False Then
      MsgBox "Invalid barcode: Not numeric"
      GoTo ExitSub
    End If
    valid$ = mBCE.CodabarCheckDigit(Barcode.Text)
    Barcode.Text = Barcode.Text + valid$
    GoTo ExitSub
  ElseIf Trim(Barcode.Text) = "" Then
    MsgBox "No barcode entered"
    GoTo ExitSub
  End If
  If IsNumeric(Barcode.Text) = False Then
    MsgBox "Invalid barcode: Not numeric"
    GoTo ExitSub
  End If
  BCode$ = Header$ + Right("00000000" + Barcode.Text, 8)
  valid$ = mBCE.CodabarCheckDigit(Left(BCode$, 13))
  Barcode.Text = Barcode.Text + valid$

ExitSub:
  Barcode.SetFocus
  Barcode.SelStart = Len(Barcode.Text)
End Sub

Private Sub mnuChangeDigits_Click()
  ChangeLib.Show 1
  Call mBCE.WriteIni(BarcodeType$, Library$, PatronCode$, ItemCode$)
End Sub

Private Sub mnuClear_Click()
  Barcode.Text = ""
End Sub

Private Sub mnuCopy_Click()
  Copy_Click
End Sub

Private Sub mnuExit_Click()
  Exit_Click
End Sub

Private Sub mnuExpand_Click()
  Expand_Click
End Sub

Private Sub mnuHelpHelp_Click()
  Help.Show 1
End Sub

Private Sub mnuVerifyCheckDigit_Click()
  If typeItem = True Then
    Header$ = ItemCode$ + Library$
  Else
    Header$ = PatronCode$ + Library$
  End If
  Barcode.Text = Trim(Barcode.Text)
  If (Len(Barcode.Text) >= 9 And Len(Barcode.Text) < 14) Or Len(Barcode.Text) > 14 Then
    MsgBox "Invalid barcode: Too many digits"
    GoTo ExitSub
  ElseIf Len(Barcode.Text) = 14 Then
    If IsNumeric(Barcode.Text) = False Then
      MsgBox "Invalid barcode: Not numeric"
      GoTo ExitSub
    End If
    valid$ = mBCE.CodabarCheckDigit(Left(Barcode.Text, 13))
    If valid$ = Right(Barcode.Text, 1) Then
      MsgBox "Check digit is correct"
    Else
      MsgBox "Check digit is not correct." + Chr(10) + Chr(10) + "Changing check digit from " + Right(Barcode.Text, 1) + " to " + valid + "."
      Barcode.Text = Left(Barcode.Text, Len(Barcode.Text) - 1) + valid
    End If
    GoTo ExitSub
  ElseIf Trim(Barcode.Text) = "" Then
    MsgBox "No barcode entered"
    GoTo ExitSub
  End If
  If IsNumeric(Barcode.Text) = False Then
    MsgBox "Invalid barcode: Not numeric"
    GoTo ExitSub
  End If
  BCode$ = Header$ + Right("000000000" + Barcode.Text, 9)
  valid$ = mBCE.CodabarCheckDigit(Left(BCode$, 13))
    If valid$ = Right(BCode$, 1) Then
      MsgBox "Check digit is correct"
    Else
      MsgBox "Check digit is not correct." + Chr(10) + Chr(10) + "Changing check digit from " + Right(BCode$, 1) + " to " + valid + "."
      Barcode.Text = Left(Barcode.Text, Len(Barcode.Text) - 1) + valid
    End If

ExitSub:
  Barcode.SetFocus
  Barcode.SelStart = Len(Barcode.Text)
End Sub

Private Sub typeItem_Click()
  If typeItem.Value = True Then BarcodeType$ = "0" Else BarcodeType$ = "1"
End Sub

Private Sub typePatron_Click()
  If typePatron.Value = True Then BarcodeType$ = "1" Else BarcodeType$ = "0"
End Sub
